﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AlgorithmCustomization {
	class Program {
		static void Main(string[] args) {
			var values = new List<int>(Enumerable.Range(1, 10));

			{
				int max2 = int.MinValue;
				int max1 = max2;
				foreach (var v in values) {
					if (v > max1) {
						max2 = max1;
						max1 = v;
					}
				}
				Console.WriteLine("2nd maximum: " + max2);
			}

			//

			{
				int max2 = int.MinValue;
				int max1 = max2;
				values.ForEach(v => {
					if (v > max1) {
						max2 = max1;
						max1 = v;
					}
				});
				Console.WriteLine("2nd maximum: " + max2);
			}
		}
	}
}
