﻿namespace CaptureByAccident {
	class Program {
		static void Main(string[] args) {
			{
				int i = 42;
				Console.WriteLine(i);

				Action a = () => {
					i = 5;
					Console.WriteLine($"Lambda: {i}");
				};
				a();

				Console.WriteLine(i);
			}

			//
			Console.WriteLine();
			//

			{
				int i = 42;
				Console.WriteLine(i);

				Action a = static () => {
					// Error: A static anonymous function cannot contain a reference to 'i'.
					// i = 5;

					var i = 5;
					Console.WriteLine($"Lambda: {i}");
				};
				a();

				Console.WriteLine(i);
			}

			//
			Console.WriteLine();
			//

			{
				int i = 42;
				Console.WriteLine(i);

				Action a = () => {
					Console.WriteLine($"Lambda's 42: {i}");		// BUG: Expected "capture by value"
				};

				i *= 2;
				Console.WriteLine(i);

				a();
			}

		}
	}
}
